package edu.stanford.multiagent.gamer;


import java.io.*;
import java.util.*;
import java.nio.IntBuffer;

import edu.stanford.multiagent.gamer.Parameters.ParamInfo;
import edu.stanford.multiagent.gamer.graphs.*;


/* Action Graph Game abstract class
 */


public abstract class ActionGraphGame extends Game
{
	protected int numActionNodes;
    protected int numPNodes;
    protected ALGraph graph;

    protected int[][] actionSets;

    public ActionGraphGame()  throws Exception
    {
	super();

    }

   /**
     * Sets the number of players based on the command line parameter.
     */
    public void initialize()
	throws Exception
    {
	super.initialize();
	
    }

    /*
     * Figures out payoff for a certain outcome
     *
     * @param outcome an array containing the actions chosen by
     * each player
     * @param player the player whose payoff should be returned
     */
    public double getPayoff( int[] outcome, int player)
    {
		double payoff=0;
			int[] D =new int [numActionNodes+numPNodes];
		for (int i=0;i<numActionNodes+numPNodes; i++){
		  D[i]=0;
		}
		
		for(int i=0;i<getNumPlayers();i++){					
		  // Action idices start at 1
		  int node = actionSets[i][outcome[i] - 1]; 
		  D[node]++;
		}

		try{ 
		  doFunctionalNodes(D, outcome);
		} catch (Exception e){
		  e.printStackTrace();
		  Global.handleError(e, "Error getting configuration of functional nodes");
		}

		int chosenNode=actionSets[player][outcome[player]-1];
		TreeMap payoffMap = (TreeMap) graph.getNodeData(chosenNode);	
		Iterator edgeIter = graph.getEdges(chosenNode);	
		int[] key={};	
		try{
		  if(payoffMap==null){
			throw new Exception("Failed to get payoff function from action node  " + chosenNode + " of the action graph");
		  }
		  if (edgeIter==null){
			throw new Exception("Failed to get edge iterator from action node " + chosenNode);
		  }
		  key = new int[graph.getNumNeighbours(chosenNode)];
		  int pos=0;
		  while (edgeIter.hasNext()){
			Edge e = (Edge) edgeIter.next();
			if (e==null) throw new Exception("Failed to get edge from action node " + chosenNode);
			int neighborNode = e.getDest();	
			key[pos] = D[neighborNode];	
			pos++;
		  }
		  payoff = (Double) payoffMap.get( IntBuffer.wrap(key)); // ??
		} catch(Exception e){
		  e.printStackTrace();
		  System.err.println("configuration:");
		  for(int i=0;i<numActionNodes+numPNodes;i++) System.err.print(D[i] + " ");
		  System.err.println("\nconfig of neighborhood:");
		  if(key!=null)for (int i=0;i<key.length;i++) System.err.print(key[i] + " ");
		  Global.handleError(e, "Error getting AGG payoff from action node " + chosenNode);
		}

		return payoff;
    }

    /* Compute configuration of the Functional Nodes.
     * This simple implementation assumes that the neighbors of functional nodes are all
     * action nodes, and the count of each functional node is the sum of the counts
     * of its neighbors. Sub-classes may define different behavior.
     */
    protected void doFunctionalNodes(int[] D, int[] outcome) throws Exception
    {
		for (int i=numActionNodes; i<numActionNodes+numPNodes; i++){
		  D[i]=0;
		  Iterator edgeIter = graph.getEdges(i);
		  while( edgeIter.hasNext() ){
		    Edge e= (Edge) edgeIter.next();
		    int neighborNode=e.getDest();
		    if (neighborNode >= numActionNodes){
			throw new Exception("neighbors of functional nodes should be action nodes!");
		    }
		    D[i] += D[neighborNode]; 
		  }
		}	
    }

    /*
     * 
     * Output the game in AGG format. 
     * @see edu.stanford.multiagent.gamer.Game#writeGame(java.io.PrintWriter)
     */
    public void writeGame (PrintWriter out)
    {

    //identifier string
    out.println("#AGG");
    
	out.println( "# Generated by " + Global.VERSION_STRING);

	out.println(SpecialOutput.commentString(getDescription(), "# "));
	
	//num of players
	out.println("\n#number of players:");
	out.println( getNumPlayers() );

	//num of action nodes
	out.println("#number of action nodes:");
	out.println( numActionNodes);
	//num of func nodes
	out.println("#number of func nodes:");
	out.println (numPNodes);

	//sizes of action sets
	out.println("\n#sizes of action sets:");
	for (int i=0;i<getNumPlayers(); i++){
	  out.print(actionSets[i].length + " ");
	}
	//action sets
	out.println("\n\n#action sets:");
	for (int i=0;i<getNumPlayers();i++){
	  for (int j=0; j<actionSets[i].length; j++){
	    out.print(actionSets[i][j] + " ");
	  }
	  out.print("\n");
	}
	//action graph
	out.println("\n\n#the action graph:");
	for(int i=0;i<numActionNodes+numPNodes; i++){
	  Iterator edgeIter = graph.getEdges(i);
	  //first output the number of neighbors
	  out.print(graph.getNumNeighbours(i));
	  while (edgeIter.hasNext()){
	    Edge e= (Edge) edgeIter.next();
	    int neighborNode=e.getDest();

	    out.print(" " + neighborNode);
	  }
	  out.print("\n");

	}

	// the types for the func nodes
	out.println("\n#the types of func nodes:");
	writePTypes(out);
	//payoffs
	out.println("\n#the payoffs:");
	writePayoffs(out);

	out.flush();
    }

    protected void writePTypes(PrintWriter out){
	out.println("#0: sum");
	out.println("#1: existence");
	out.println("#2: highest");
	out.println("#3: lowest");
	out.println("#10: extended sum");
	out.println("#11: extended existence");
	out.println("#12: extended highest");
	out.println("#13: extended lowest");
	out.println("#Extended versions of type 0-3 require further parameters:");
	out.println("# type default_value [list of |action nodes| weights]\n");
	
	for (int i=numActionNodes; i<numActionNodes+numPNodes; i++){
		try {
		 	FunctionNode fn = graph.getFN(i);
		 	int type = fn.getType();
		 	
		 	switch(type)
		    {
		    case FunctionNode.SUM:
		    	out.println ( "0" );
				break;
		    case FunctionNode.EXTENDED_SUM:
		    	int defval = fn.getDefaultValue();
		    	int[] weights = fn.getWeights(numActionNodes); // workaround to have |S| integers in brackets instead of |numnei| when calling int[] weights = fn.getWeights(); instead
		    	out.println("10 "+ defval +" "+ Arrays.toString(weights).replace(",", ""));
		    	break;
		 	default:
		 		throw new Exception("Output for function node of type "+type+" is yet to be implemented.");
		    }
		} catch (Exception e) {
			Global.handleError(e, "Failed to format output!");
		}	
	}   
    }

    /*
     * 
     * Output the payoffs in AGG format.
     * 
     */
    protected void writePayoffs(PrintWriter out) {
	
	//output the payoffs for each action node

	out.println("#now the payoff values: one row per action node.");
	out.println("#For each row: first, the type of the payoff format");
	out.println("#Then payoffs are given in lexicographical order of the input configurations");
	
	for(int i=0;i<numActionNodes; i++) {
	  TreeMap payoffMap = (TreeMap) graph.getNodeData(i);
	  Iterator payoffIter= payoffMap.values().iterator();
	  //out.println("DEBUG: i= " + i);

	  out.print("0\t");
	  while (payoffIter.hasNext()){
	    double payoff  = (Double)  payoffIter.next();
            try{
	      out.print (getOutputPayoff(payoff) + " ");
	    }
	    catch (Exception e) {
	      Global.handleError(e, "Failed to format output!");
	    }
	  }
	  out.println();

	}
	
    }

    
    /*
     * 
     * Set min and max payoff.
     * Used by getOutputPayoff when outputting normalized 
     * payoffs. 
     * This function overwrites the one in class Game, which 
     * was based on the normal form representation.
     * 
     */
    public void setNormMinAndMax(){
    	TreeMap<IntBuffer, Double> m = (TreeMap<IntBuffer, Double>) graph.getNodeData(0);
    	oldMax=Collections.max(m.values());
    	oldMin=Collections.min(m.values());
    	for(int i=1;i<numActionNodes; i++) {
    		TreeMap<IntBuffer, Double> payoffMap = (TreeMap<IntBuffer, Double>) graph.getNodeData(i);
    		oldMax=Math.max(oldMax,Collections.max(payoffMap.values()));
    		oldMin=Math.min(oldMin,Collections.min(payoffMap.values()));
    	}
    	minAndMaxSet = true;
    }
    
    
  
    /*
     * Returns (for each action node) the possible 
     * configurations over the action's neighborhood
     * 
     */
    protected TreeSet[] initConfigs()	
    {
		int n = getNumPlayers();
		TreeSet[] m = new TreeSet[numActionNodes];
		for (int i = 0; i < numActionNodes; i++)		
			m[i] = new TreeSet<IntBuffer>();
		for (int player = 0; player < n; player++)	
		{
		    for (int jj = 0; jj < getNumActions(player); jj++)  //for each of player's actions
		    {
				int node = actionSets[player][jj];
				int k = graph.getNumNeighbours(node);	
				TreeSet[] configs = new TreeSet[n+1];
				configs[0] = new TreeSet<IntBuffer>();
				int[] key0 = new int[k];				
				for (int i = 0; i < k; i++) key0[i] = 0;
				configs[0].add(IntBuffer.wrap(key0));	
				for (int i = 1; i <= n; i++)			
				{
				    configs[i] = new TreeSet<IntBuffer>();
				    Iterator prevIter = configs[i - 1].iterator();
				    while (prevIter.hasNext())			
				    {
						IntBuffer t = ((IntBuffer)prevIter.next());
						int[] pkey = (int[])t.array();
						for (int j = 0; j < getNumActions(i - 1); j++) //for each of i's action
						{
						    if (i - 1 == player && j != jj) continue; 
						    int act = actionSets[i - 1][j];
						    int[] key = new int[k];
						    Iterator edgeIter = graph.getEdges(node);	
						    for (int idx = 0; edgeIter.hasNext(); idx++)
						    {
								Edge e = (Edge)edgeIter.next();
								int nei = e.getDest();	
								key[idx] = pkey[idx];	
								
								// Start EDITED FOR FUNCTION NODES
								if(nei>=numActionNodes)
								{
									if(graph.areNeighbours(nei, act))
									{
										try{
											FunctionNode fn = graph.getFN(nei);
											if(fn.getType()==FunctionNode.SUM)
												key[idx]++;
											else if(fn.getType()==FunctionNode.EXTENDED_SUM)
												key[idx] += fn.getWeight(act);
											else
												Global.handleError("Error initializing configuration: Not yet implemented for Function Nodes other than SUM and EXTENDED SUM.");
										} catch (Exception error){
											Global.handleError(error, "Error getting weight of function node");
										}
										
									}
									continue;
								}
								// End EDITED FOR FUNCTION NODES
								else if (act == nei) key[idx]++;
						    }
						    configs[i].add(IntBuffer.wrap(key));
			
						}
				    }
				}
				m[node].addAll(configs[n]);
		    }
		}
		return m;
    }
}


